diff --git a/pki/base/common/src/com/netscape/cms/crl/CMSIssuingDistributionPointExtension.java b/pki/base/common/src/com/netscape/cms/crl/CMSIssuingDistributionPointExtension.java
index 21bd86b0acffa1c804668af34dd0cf6d75d26df1..4253584ce6fd9aa4b24883242f8257e80cdbe3b8 100644
--- a/pki/base/common/src/com/netscape/cms/crl/CMSIssuingDistributionPointExtension.java
+++ b/pki/base/common/src/com/netscape/cms/crl/CMSIssuingDistributionPointExtension.java
@@ -229,9 +229,9 @@ public class CMSIssuingDistributionPointExtension
             log(ILogger.LL_FAILURE, CMS.getLogMessage("CRL_CREATE_DIST_POINT_INVALID", e.toString()));
         }
         if (pointType != null && pointType.length() > 0) {
-            nvp.add("pointType", pointType);
+            nvp.put("pointType", pointType);
         } else {
-            nvp.add("pointType", "");
+            nvp.put("pointType", "");
         }
 
         String pointName = null;
@@ -244,9 +244,9 @@ public class CMSIssuingDistributionPointExtension
             log(ILogger.LL_FAILURE, CMS.getLogMessage("CRL_CREATE_DIST_POINT_INVALID", e.toString()));
         }
         if (pointName != null && pointName.length() > 0) {
-            nvp.add("pointName", pointName);
+            nvp.put("pointName", pointName);
         } else {
-            nvp.add("pointName", "");
+            nvp.put("pointName", "");
         }
 
         String reasons = null;
@@ -257,17 +257,17 @@ public class CMSIssuingDistributionPointExtension
             log(ILogger.LL_FAILURE, CMS.getLogMessage("CRL_INVALID_PROPERTY", PROP_REASONS, e.toString()));
         }
         if (reasons != null && reasons.length() > 0) {
-            nvp.add(PROP_REASONS, reasons);
+            nvp.put(PROP_REASONS, reasons);
         } else {
-            nvp.add(PROP_REASONS, "");
+            nvp.put(PROP_REASONS, "");
         }
 
         try {
             boolean caCertsOnly = config.getBoolean(PROP_CACERTS, false);
 
-            nvp.add(PROP_CACERTS, String.valueOf(caCertsOnly));
+            nvp.put(PROP_CACERTS, String.valueOf(caCertsOnly));
         } catch (EBaseException e) {
-            nvp.add(PROP_CACERTS, "false");
+            nvp.put(PROP_CACERTS, "false");
             log(ILogger.LL_FAILURE, CMS.getLogMessage("CRL_INVALID_PROPERTY", "caCertsOnly", e.toString()));
         }
         // Disable these for now unitl we support them fully
diff --git a/pki/base/common/src/com/netscape/cms/logging/LogFile.java b/pki/base/common/src/com/netscape/cms/logging/LogFile.java
index 0a5f18579a552af2df9199e3bc4b34d8341f2d9c..5144bf16df3ef176c8d96021fc02f0575b96d228 100644
--- a/pki/base/common/src/com/netscape/cms/logging/LogFile.java
+++ b/pki/base/common/src/com/netscape/cms/logging/LogFile.java
@@ -1340,7 +1340,7 @@ public class LogFile implements ILogEventListener, IExtendedPluginInfo {
         try {
             entries = readEntry(maxLine, level, source, fName);
             for (int i = 0; i < entries.size(); i++) {
-                params.add(Integer.toString(i) +
+                params.put(Integer.toString(i) +
                         ((LogEntry) entries.elementAt(i)).getEntry(), "");
             }
         } catch (Exception e) {
diff --git a/pki/base/common/src/com/netscape/cms/logging/RollingLogFile.java b/pki/base/common/src/com/netscape/cms/logging/RollingLogFile.java
index e085937e53253cd4d2b19d44e53eff43cc5f89a3..93455e9fe4a6f7b41b2cb4601d3ae1eb29e81ad3 100644
--- a/pki/base/common/src/com/netscape/cms/logging/RollingLogFile.java
+++ b/pki/base/common/src/com/netscape/cms/logging/RollingLogFile.java
@@ -524,7 +524,7 @@ public class RollingLogFile extends LogFile {
 
         files = fileList();
         for (int i = 0; i < files.length; i++) {
-            params.add(files[i], "");
+            params.put(files[i], "");
         }
         return params;
     }
diff --git a/pki/base/common/src/com/netscape/cms/ocsp/DefStore.java b/pki/base/common/src/com/netscape/cms/ocsp/DefStore.java
index d3b5d545e8c859298947c7d2acbda119095baa0c..2482d69af26e0866b73f81465e85111931de8395 100644
--- a/pki/base/common/src/com/netscape/cms/ocsp/DefStore.java
+++ b/pki/base/common/src/com/netscape/cms/ocsp/DefStore.java
@@ -798,13 +798,13 @@ public class DefStore implements IDefStore, IExtendedPluginInfo {
         try {
             NameValuePairs params = new NameValuePairs();
 
-            params.add(Constants.PR_OCSPSTORE_IMPL_NAME,
+            params.put(Constants.PR_OCSPSTORE_IMPL_NAME,
                     mConfig.getString("class"));
-            params.add(PROP_NOT_FOUND_GOOD,
+            params.put(PROP_NOT_FOUND_GOOD,
                     mConfig.getString(PROP_NOT_FOUND_GOOD, "true"));
-            params.add(PROP_BY_NAME,
+            params.put(PROP_BY_NAME,
                     mConfig.getString(PROP_BY_NAME, "true"));
-            params.add(PROP_INCLUDE_NEXT_UPDATE,
+            params.put(PROP_INCLUDE_NEXT_UPDATE,
                     mConfig.getString(PROP_INCLUDE_NEXT_UPDATE, "false"));
             return params;
         } catch (Exception e) {
@@ -814,12 +814,9 @@ public class DefStore implements IDefStore, IExtendedPluginInfo {
 
     public void setConfigParameters(NameValuePairs pairs)
             throws EBaseException {
-        Enumeration<String> k = pairs.getNames();
 
-        while (k.hasMoreElements()) {
-            String key = (String) k.nextElement();
-
-            mConfig.put(key, pairs.getValue(key));
+        for (String key : pairs.keySet()) {
+            mConfig.put(key, pairs.get(key));
         }
     }
 
diff --git a/pki/base/common/src/com/netscape/cms/ocsp/LDAPStore.java b/pki/base/common/src/com/netscape/cms/ocsp/LDAPStore.java
index 9e340d0f7a4c40afee728ea42337c30539415c30..ac6534afd2db454a8dcd43ae2297e0cfbdf20dac 100644
--- a/pki/base/common/src/com/netscape/cms/ocsp/LDAPStore.java
+++ b/pki/base/common/src/com/netscape/cms/ocsp/LDAPStore.java
@@ -531,34 +531,34 @@ public class LDAPStore implements IDefStore, IExtendedPluginInfo {
         try {
             NameValuePairs params = new NameValuePairs();
 
-            params.add(Constants.PR_OCSPSTORE_IMPL_NAME,
+            params.put(Constants.PR_OCSPSTORE_IMPL_NAME,
                     mConfig.getString("class"));
             int num = mConfig.getInteger(PROP_NUM_CONNS, 0);
 
-            params.add(PROP_NUM_CONNS, Integer.toString(num));
+            params.put(PROP_NUM_CONNS, Integer.toString(num));
             for (int i = 0; i < num; i++) {
-                params.add(PROP_HOST + Integer.toString(i),
+                params.put(PROP_HOST + Integer.toString(i),
                         mConfig.getString(PROP_HOST +
                                 Integer.toString(i), ""));
-                params.add(PROP_PORT + Integer.toString(i),
+                params.put(PROP_PORT + Integer.toString(i),
                         mConfig.getString(PROP_PORT +
                                 Integer.toString(i), "389"));
-                params.add(PROP_BASE_DN + Integer.toString(i),
+                params.put(PROP_BASE_DN + Integer.toString(i),
                         mConfig.getString(PROP_BASE_DN +
                                 Integer.toString(i), ""));
-                params.add(PROP_REFRESH_IN_SEC + Integer.toString(i),
+                params.put(PROP_REFRESH_IN_SEC + Integer.toString(i),
                         mConfig.getString(PROP_REFRESH_IN_SEC +
                                 Integer.toString(i), Integer.toString(DEF_REFRESH_IN_SEC)));
             }
-            params.add(PROP_BY_NAME,
+            params.put(PROP_BY_NAME,
                     mConfig.getString(PROP_BY_NAME, "true"));
-            params.add(PROP_CA_CERT_ATTR,
+            params.put(PROP_CA_CERT_ATTR,
                     mConfig.getString(PROP_CA_CERT_ATTR, DEF_CA_CERT_ATTR));
-            params.add(PROP_CRL_ATTR,
+            params.put(PROP_CRL_ATTR,
                     mConfig.getString(PROP_CRL_ATTR, DEF_CRL_ATTR));
-            params.add(PROP_NOT_FOUND_GOOD,
+            params.put(PROP_NOT_FOUND_GOOD,
                     mConfig.getString(PROP_NOT_FOUND_GOOD, "true"));
-            params.add(PROP_INCLUDE_NEXT_UPDATE,
+            params.put(PROP_INCLUDE_NEXT_UPDATE,
                     mConfig.getString(PROP_INCLUDE_NEXT_UPDATE, "false"));
             return params;
         } catch (Exception e) {
@@ -568,12 +568,9 @@ public class LDAPStore implements IDefStore, IExtendedPluginInfo {
 
     public void setConfigParameters(NameValuePairs pairs)
             throws EBaseException {
-        Enumeration<String> k = pairs.getNames();
 
-        while (k.hasMoreElements()) {
-            String key = k.nextElement();
-
-            mConfig.put(key, pairs.getValue(key));
+        for (String key : pairs.keySet()) {
+            mConfig.put(key, pairs.get(key));
         }
     }
 }
diff --git a/pki/base/common/src/com/netscape/cms/profile/common/BasicProfile.java b/pki/base/common/src/com/netscape/cms/profile/common/BasicProfile.java
index cab5941888d7c984eee8192eb6bfae7afbdb00b1..7f624cb8b71d193f970745581996a5930f11fa1d 100644
--- a/pki/base/common/src/com/netscape/cms/profile/common/BasicProfile.java
+++ b/pki/base/common/src/com/netscape/cms/profile/common/BasicProfile.java
@@ -615,15 +615,12 @@ public abstract class BasicProfile implements IProfile {
                     outputInfo.getName(Locale.getDefault()));
             outputStore.putString(prefix + "class_id", outputId);
 
-            Enumeration<String> enum1 = nvps.getNames();
+            for (String name : nvps.keySet()) {
 
-            while (enum1.hasMoreElements()) {
-                String name = enum1.nextElement();
-
-                outputStore.putString(prefix + "params." + name, nvps.getValue(name));
+                outputStore.putString(prefix + "params." + name, nvps.get(name));
                 try {
                     if (output != null) {
-                        output.setConfig(name, nvps.getValue(name));
+                        output.setConfig(name, nvps.get(name));
                     }
                 } catch (EBaseException e) {
                     CMS.debug(e.toString());
@@ -718,15 +715,12 @@ public abstract class BasicProfile implements IProfile {
                     inputInfo.getName(Locale.getDefault()));
             inputStore.putString(prefix + "class_id", inputId);
 
-            Enumeration<String> enum1 = nvps.getNames();
+            for (String name : nvps.keySet()) {
 
-            while (enum1.hasMoreElements()) {
-                String name = enum1.nextElement();
-
-                inputStore.putString(prefix + "params." + name, nvps.getValue(name));
+                inputStore.putString(prefix + "params." + name, nvps.get(name));
                 try {
                     if (input != null) {
-                        input.setConfig(name, nvps.getValue(name));
+                        input.setConfig(name, nvps.get(name));
                     }
                 } catch (EBaseException e) {
                     CMS.debug(e.toString());
diff --git a/pki/base/common/src/com/netscape/cms/profile/def/AuthInfoAccessExtDefault.java b/pki/base/common/src/com/netscape/cms/profile/def/AuthInfoAccessExtDefault.java
index f23b7e24cada5aefacdb75e0ea4297d4172ddeca..76ea4e1436ddc30ea75305385f82f6d3ee6aa647 100644
--- a/pki/base/common/src/com/netscape/cms/profile/def/AuthInfoAccessExtDefault.java
+++ b/pki/base/common/src/com/netscape/cms/profile/def/AuthInfoAccessExtDefault.java
@@ -225,7 +225,7 @@ public class AuthInfoAccessExtDefault extends EnrollExtDefault {
                 }
                 boolean critical = ext.isCritical();
 
-                Vector v = parseRecords(value);
+                Vector<NameValuePairs> v = parseRecords(value);
                 int size = v.size();
 
                 ext = new AuthInfoAccessExtension(critical);
@@ -235,20 +235,18 @@ public class AuthInfoAccessExtDefault extends EnrollExtDefault {
                 String enable = null;
 
                 for (int i = 0; i < size; i++) {
-                    NameValuePairs nvps = (NameValuePairs) v.elementAt(i);
-                    Enumeration<String> names = nvps.getNames();
+                    NameValuePairs nvps = v.elementAt(i);
 
-                    while (names.hasMoreElements()) {
-                        String name1 = names.nextElement();
+                    for (String name1 : nvps.keySet()) {
 
                         if (name1.equals(AD_METHOD)) {
-                            method = nvps.getValue(name1);
+                            method = nvps.get(name1);
                         } else if (name1.equals(AD_LOCATION_TYPE)) {
-                            locationType = nvps.getValue(name1);
+                            locationType = nvps.get(name1);
                         } else if (name1.equals(AD_LOCATION)) {
-                            location = nvps.getValue(name1);
+                            location = nvps.get(name1);
                         } else if (name1.equals(AD_ENABLE)) {
-                            enable = nvps.getValue(name1);
+                            enable = nvps.get(name1);
                         }
                     }
 
@@ -352,18 +350,18 @@ public class AuthInfoAccessExtDefault extends EnrollExtDefault {
                     des = ext.getAccessDescription(i);
                 }
                 if (des == null) {
-                    np.add(AD_METHOD, "");
-                    np.add(AD_LOCATION_TYPE, "");
-                    np.add(AD_LOCATION, "");
-                    np.add(AD_ENABLE, "false");
+                    np.put(AD_METHOD, "");
+                    np.put(AD_LOCATION_TYPE, "");
+                    np.put(AD_LOCATION, "");
+                    np.put(AD_ENABLE, "false");
                 } else {
                     ObjectIdentifier methodOid = des.getMethod();
                     GeneralName gn = des.getLocation();
 
-                    np.add(AD_METHOD, methodOid.toString());
-                    np.add(AD_LOCATION_TYPE, getGeneralNameType(gn));
-                    np.add(AD_LOCATION, getGeneralNameValue(gn));
-                    np.add(AD_ENABLE, "true");
+                    np.put(AD_METHOD, methodOid.toString());
+                    np.put(AD_LOCATION_TYPE, getGeneralNameType(gn));
+                    np.put(AD_LOCATION, getGeneralNameValue(gn));
+                    np.put(AD_ENABLE, "true");
                 }
                 recs.addElement(np);
             }
diff --git a/pki/base/common/src/com/netscape/cms/profile/def/CRLDistributionPointsExtDefault.java b/pki/base/common/src/com/netscape/cms/profile/def/CRLDistributionPointsExtDefault.java
index a95ec6b7d08cf4d21244dfc8e0cd793081ab8fa7..c7a0f9abd2ebd12e2187b8a925bc6b520e7a2b2e 100644
--- a/pki/base/common/src/com/netscape/cms/profile/def/CRLDistributionPointsExtDefault.java
+++ b/pki/base/common/src/com/netscape/cms/profile/def/CRLDistributionPointsExtDefault.java
@@ -247,8 +247,7 @@ public class CRLDistributionPointsExtDefault extends EnrollExtDefault {
                 int i = 0;
 
                 for (; i < size; i++) {
-                    NameValuePairs nvps = (NameValuePairs) v.elementAt(i);
-                    Enumeration<String> names = nvps.getNames();
+                    NameValuePairs nvps = v.elementAt(i);
                     String pointType = null;
                     String pointValue = null;
                     String issuerType = null;
@@ -256,21 +255,20 @@ public class CRLDistributionPointsExtDefault extends EnrollExtDefault {
                     String enable = null;
                     CRLDistributionPoint cdp = new CRLDistributionPoint();
 
-                    while (names.hasMoreElements()) {
-                        String name1 = (String) names.nextElement();
+                    for (String name1 : nvps.keySet()) {
 
                         if (name1.equals(REASONS)) {
-                            addReasons(locale, cdp, REASONS, nvps.getValue(name1));
+                            addReasons(locale, cdp, REASONS, nvps.get(name1));
                         } else if (name1.equals(POINT_TYPE)) {
-                            pointType = nvps.getValue(name1);
+                            pointType = nvps.get(name1);
                         } else if (name1.equals(POINT_NAME)) {
-                            pointValue = nvps.getValue(name1);
+                            pointValue = nvps.get(name1);
                         } else if (name1.equals(ISSUER_TYPE)) {
-                            issuerType = nvps.getValue(name1);
+                            issuerType = nvps.get(name1);
                         } else if (name1.equals(ISSUER_NAME)) {
-                            issuerValue = nvps.getValue(name1);
+                            issuerValue = nvps.get(name1);
                         } else if (name1.equals(ENABLE)) {
-                            enable = nvps.getValue(name1);
+                            enable = nvps.get(name1);
                         }
                     }
 
@@ -466,12 +464,12 @@ public class CRLDistributionPointsExtDefault extends EnrollExtDefault {
     protected NameValuePairs buildEmptyGeneralNames() {
         NameValuePairs pairs = new NameValuePairs();
 
-        pairs.add(POINT_TYPE, "");
-        pairs.add(POINT_NAME, "");
-        pairs.add(REASONS, "");
-        pairs.add(ISSUER_TYPE, "");
-        pairs.add(ISSUER_NAME, "");
-        pairs.add(ENABLE, "false");
+        pairs.put(POINT_TYPE, "");
+        pairs.put(POINT_NAME, "");
+        pairs.put(REASONS, "");
+        pairs.put(ISSUER_TYPE, "");
+        pairs.put(ISSUER_NAME, "");
+        pairs.put(ENABLE, "false");
         return pairs;
     }
 
@@ -483,16 +481,16 @@ public class CRLDistributionPointsExtDefault extends EnrollExtDefault {
         RDN rdn = null;
         boolean hasFullName = false;
 
-        pairs.add(ENABLE, "true");
+        pairs.put(ENABLE, "true");
         if (gns == null) {
             rdn = p.getRelativeName();
             if (rdn != null) {
                 hasFullName = true;
-                pairs.add(POINT_TYPE, RELATIVETOISSUER);
-                pairs.add(POINT_NAME, rdn.toString());
+                pairs.put(POINT_TYPE, RELATIVETOISSUER);
+                pairs.put(POINT_NAME, rdn.toString());
             } else {
-                pairs.add(POINT_TYPE, "");
-                pairs.add(POINT_NAME, "");
+                pairs.put(POINT_TYPE, "");
+                pairs.put(POINT_NAME, "");
             }
         } else {
             GeneralName gn = (GeneralName) gns.elementAt(0);
@@ -501,30 +499,30 @@ public class CRLDistributionPointsExtDefault extends EnrollExtDefault {
                 hasFullName = true;
                 int type = gn.getType();
 
-                pairs.add(POINT_TYPE, getGeneralNameType(gn));
-                pairs.add(POINT_NAME, getGeneralNameValue(gn));
+                pairs.put(POINT_TYPE, getGeneralNameType(gn));
+                pairs.put(POINT_NAME, getGeneralNameValue(gn));
             }
         }
 
         if (!hasFullName) {
-            pairs.add(POINT_TYPE, GN_DIRECTORY_NAME);
-            pairs.add(POINT_NAME, "");
+            pairs.put(POINT_TYPE, GN_DIRECTORY_NAME);
+            pairs.put(POINT_NAME, "");
         }
 
         BitArray reasons = p.getReasons();
         String s = convertBitArrayToReasonNames(reasons);
 
         if (s.length() > 0) {
-            pairs.add(REASONS, s);
+            pairs.put(REASONS, s);
         } else {
-            pairs.add(REASONS, "");
+            pairs.put(REASONS, "");
         }
 
         gns = p.getCRLIssuer();
 
         if (gns == null) {
-            pairs.add(ISSUER_TYPE, GN_DIRECTORY_NAME);
-            pairs.add(ISSUER_NAME, "");
+            pairs.put(ISSUER_TYPE, GN_DIRECTORY_NAME);
+            pairs.put(ISSUER_NAME, "");
         } else {
             GeneralName gn = (GeneralName) gns.elementAt(0);
 
@@ -532,8 +530,8 @@ public class CRLDistributionPointsExtDefault extends EnrollExtDefault {
                 hasFullName = true;
                 int type = gn.getType();
 
-                pairs.add(ISSUER_TYPE, getGeneralNameType(gn));
-                pairs.add(ISSUER_NAME, getGeneralNameValue(gn));
+                pairs.put(ISSUER_TYPE, getGeneralNameType(gn));
+                pairs.put(ISSUER_NAME, getGeneralNameValue(gn));
             }
         }
         return pairs;
diff --git a/pki/base/common/src/com/netscape/cms/profile/def/EnrollDefault.java b/pki/base/common/src/com/netscape/cms/profile/def/EnrollDefault.java
index 855cd92c7eb538f5e23ba21ddea363ca006bd818..5310986d543b04eac316f78eacbf4a8675888968 100644
--- a/pki/base/common/src/com/netscape/cms/profile/def/EnrollDefault.java
+++ b/pki/base/common/src/com/netscape/cms/profile/def/EnrollDefault.java
@@ -641,11 +641,9 @@ public abstract class EnrollDefault implements IPolicyDefault, ICertInfoPolicyDe
             sb.append("Record #");
             sb.append(i);
             sb.append("\r\n");
-            Enumeration<String> e = pairs.getNames();
 
-            while (e.hasMoreElements()) {
-                String key = e.nextElement();
-                String val = pairs.getValue(key);
+            for (String key : pairs.keySet()) {
+                String val = pairs.get(key);
 
                 sb.append(key);
                 sb.append(":");
@@ -691,9 +689,9 @@ public abstract class EnrollDefault implements IPolicyDefault, ICertInfoPolicyDe
                 throw new EPropertyException("Bad Input Format");
             } else {
                 if (pos == (token.length() - 1)) {
-                    nvps.add(token.substring(0, pos), "");
+                    nvps.put(token.substring(0, pos), "");
                 } else {
-                    nvps.add(token.substring(0, pos), token.substring(pos + 1));
+                    nvps.put(token.substring(0, pos), token.substring(pos + 1));
                 }
             }
         }
diff --git a/pki/base/common/src/com/netscape/cms/profile/def/FreshestCRLExtDefault.java b/pki/base/common/src/com/netscape/cms/profile/def/FreshestCRLExtDefault.java
index a2de3f491f5bdffb5b4bd9ac1b64fb2038c7f5ac..739fd3448a890ee16cda9ea4f3b8fd9b7c35d36e 100644
--- a/pki/base/common/src/com/netscape/cms/profile/def/FreshestCRLExtDefault.java
+++ b/pki/base/common/src/com/netscape/cms/profile/def/FreshestCRLExtDefault.java
@@ -230,8 +230,7 @@ public class FreshestCRLExtDefault extends EnrollExtDefault {
                 int i = 0;
 
                 for (; i < size; i++) {
-                    NameValuePairs nvps = (NameValuePairs) v.elementAt(i);
-                    Enumeration<String> names = nvps.getNames();
+                    NameValuePairs nvps = v.elementAt(i);
                     String pointType = null;
                     String pointValue = null;
                     String issuerType = null;
@@ -239,19 +238,18 @@ public class FreshestCRLExtDefault extends EnrollExtDefault {
                     String enable = null;
                     CRLDistributionPoint cdp = new CRLDistributionPoint();
 
-                    while (names.hasMoreElements()) {
-                        String name1 = (String) names.nextElement();
+                    for (String name1 : nvps.keySet()) {
 
                         if (name1.equals(POINT_TYPE)) {
-                            pointType = nvps.getValue(name1);
+                            pointType = nvps.get(name1);
                         } else if (name1.equals(POINT_NAME)) {
-                            pointValue = nvps.getValue(name1);
+                            pointValue = nvps.get(name1);
                         } else if (name1.equals(ISSUER_TYPE)) {
-                            issuerType = nvps.getValue(name1);
+                            issuerType = nvps.get(name1);
                         } else if (name1.equals(ISSUER_NAME)) {
-                            issuerValue = nvps.getValue(name1);
+                            issuerValue = nvps.get(name1);
                         } else if (name1.equals(ENABLE)) {
-                            enable = nvps.getValue(name1);
+                            enable = nvps.get(name1);
                         }
                     }
 
@@ -409,11 +407,11 @@ public class FreshestCRLExtDefault extends EnrollExtDefault {
     protected NameValuePairs buildEmptyGeneralNames() {
         NameValuePairs pairs = new NameValuePairs();
 
-        pairs.add(POINT_TYPE, "");
-        pairs.add(POINT_NAME, "");
-        pairs.add(ISSUER_TYPE, "");
-        pairs.add(ISSUER_NAME, "");
-        pairs.add(ENABLE, "false");
+        pairs.put(POINT_TYPE, "");
+        pairs.put(POINT_NAME, "");
+        pairs.put(ISSUER_TYPE, "");
+        pairs.put(ISSUER_NAME, "");
+        pairs.put(ENABLE, "false");
         return pairs;
     }
 
@@ -424,10 +422,10 @@ public class FreshestCRLExtDefault extends EnrollExtDefault {
 
         boolean hasFullName = false;
 
-        pairs.add(ENABLE, "true");
+        pairs.put(ENABLE, "true");
         if (gns == null) {
-            pairs.add(POINT_TYPE, "");
-            pairs.add(POINT_NAME, "");
+            pairs.put(POINT_TYPE, "");
+            pairs.put(POINT_NAME, "");
         } else {
             GeneralName gn = (GeneralName) gns.elementAt(0);
 
@@ -435,21 +433,21 @@ public class FreshestCRLExtDefault extends EnrollExtDefault {
                 hasFullName = true;
                 int type = gn.getType();
 
-                pairs.add(POINT_TYPE, getGeneralNameType(gn));
-                pairs.add(POINT_NAME, getGeneralNameValue(gn));
+                pairs.put(POINT_TYPE, getGeneralNameType(gn));
+                pairs.put(POINT_NAME, getGeneralNameValue(gn));
             }
         }
 
         if (!hasFullName) {
-            pairs.add(POINT_TYPE, GN_DIRECTORY_NAME);
-            pairs.add(POINT_NAME, "");
+            pairs.put(POINT_TYPE, GN_DIRECTORY_NAME);
+            pairs.put(POINT_NAME, "");
         }
 
         gns = p.getCRLIssuer();
 
         if (gns == null) {
-            pairs.add(ISSUER_TYPE, GN_DIRECTORY_NAME);
-            pairs.add(ISSUER_NAME, "");
+            pairs.put(ISSUER_TYPE, GN_DIRECTORY_NAME);
+            pairs.put(ISSUER_NAME, "");
         } else {
             GeneralName gn = (GeneralName) gns.elementAt(0);
 
@@ -457,8 +455,8 @@ public class FreshestCRLExtDefault extends EnrollExtDefault {
                 hasFullName = true;
                 int type = gn.getType();
 
-                pairs.add(ISSUER_TYPE, getGeneralNameType(gn));
-                pairs.add(ISSUER_NAME, getGeneralNameValue(gn));
+                pairs.put(ISSUER_TYPE, getGeneralNameType(gn));
+                pairs.put(ISSUER_NAME, getGeneralNameValue(gn));
             }
         }
         return pairs;
diff --git a/pki/base/common/src/com/netscape/cms/profile/def/NameConstraintsExtDefault.java b/pki/base/common/src/com/netscape/cms/profile/def/NameConstraintsExtDefault.java
index c513c332ba4fa380499bbd04756cd2c0f95ce494..e57d040674a9efe5bb3055fb64fe7d047cd43588 100644
--- a/pki/base/common/src/com/netscape/cms/profile/def/NameConstraintsExtDefault.java
+++ b/pki/base/common/src/com/netscape/cms/profile/def/NameConstraintsExtDefault.java
@@ -366,20 +366,18 @@ public class NameConstraintsExtDefault extends EnrollExtDefault {
         Vector<GeneralSubtree> subtrees = new Vector<GeneralSubtree>();
 
         for (int i = 0; i < size; i++) {
-            NameValuePairs nvps = (NameValuePairs) v.elementAt(i);
-            Enumeration<String> names = nvps.getNames();
+            NameValuePairs nvps = v.elementAt(i);
 
-            while (names.hasMoreElements()) {
-                String name1 = (String) names.nextElement();
+            for (String name1 : nvps.keySet()) {
 
                 if (name1.equals(GENERAL_NAME_CHOICE)) {
-                    choice = nvps.getValue(name1);
+                    choice = nvps.get(name1);
                 } else if (name1.equals(GENERAL_NAME_VALUE)) {
-                    val = nvps.getValue(name1);
+                    val = nvps.get(name1);
                 } else if (name1.equals(MIN_VALUE)) {
-                    minS = nvps.getValue(name1);
+                    minS = nvps.get(name1);
                 } else if (name1.equals(MAX_VALUE)) {
-                    maxS = nvps.getValue(name1);
+                    maxS = nvps.get(name1);
                 }
             }
 
@@ -527,11 +525,11 @@ public class NameConstraintsExtDefault extends EnrollExtDefault {
 
             NameValuePairs pairs = new NameValuePairs();
 
-            pairs.add(GENERAL_NAME_CHOICE, type);
-            pairs.add(GENERAL_NAME_VALUE, getGeneralNameValue(gn));
-            pairs.add(MIN_VALUE, Integer.toString(min));
-            pairs.add(MAX_VALUE, Integer.toString(max));
-            pairs.add(ENABLE, "true");
+            pairs.put(GENERAL_NAME_CHOICE, type);
+            pairs.put(GENERAL_NAME_VALUE, getGeneralNameValue(gn));
+            pairs.put(MIN_VALUE, Integer.toString(min));
+            pairs.put(MAX_VALUE, Integer.toString(max));
+            pairs.put(ENABLE, "true");
 
             recs.addElement(pairs);
         }
